<!DOCTYPE html><html lang="zh-cn"><head><meta charset="utf-8"><meta name="viewport" content="width=device-width,initial-scale=1.0,minimum-scale=1.0,maximum-scale=1.0,user-scalable=no"><meta name="format-detection" content="telephone=no"><meta name="format-detection" content="email=no"><meta name="description"><meta name="keywords" content="Hexo, Gruntjs, Nodejs, Reactjs, Vuejs"><title>碰到IMAGE类型数据后，误以为是UIIAMGE - Chen's Blog</title><link rel="stylesheet" href="/css/main_style.min.css"><link rel="icon" href="/favicon.ico"></head><body><div class="post-header"><img class="background" src="/default_images/post_background.jpg"><div class="post-title"><h1 class="title">碰到IMAGE类型数据后，误以为是UIIAMGE</h1><ul class="meta"><li><i class="icon icon-author"></i>Donghouhe</li><li><i class="icon icon-clock"></i>1 Minutes</li><li><i class="icon icon-calendar"></i>December 16, 2016</li></ul></div></div><div class="article-content"><h5 id="在一台SQl-SERVER中有一条存储了图片数据的信息，长这样，-事实上这是而今只保存的，而逗号以及只读取到一部分完全是处理的结果"><a href="#在一台SQl-SERVER中有一条存储了图片数据的信息，长这样，-事实上这是而今只保存的，而逗号以及只读取到一部分完全是处理的结果" class="headerlink" title="在一台SQl SERVER中有一条存储了图片数据的信息，长这样，(事实上这是而今只保存的，而逗号以及只读取到一部分完全是处理的结果        )"></a>在一台SQl SERVER中有一条存储了图片数据的信息，长这样，(事实上这是而今只保存的，而逗号以及只读取到一部分完全是处理的结果        )</h5><pre><code>255,216,255,224,0,16,74,70,73,70,0,1,1,1,1,44,1,44,0,0,255,219,0,67,0,2,1,1,2,1,1,2,2,2,2,2,2,2,2,3,5,3,3,3,3,3,6,4,4,3,5,7,6,7,7,7,6,7,7,8,9,11,9,8,8,10,8,7,7,10,13,10,10,11,12,12,12,12,7,9,14,15,13,12,14,11,12,12,12,255,219,0,67,1,2,2,2,3,3,3,6,3,3,6,12,8,7,8,12,12,12,12,12,12,12,12,12,12,12,12,12,12,12,12,12,12,12,12,12,12,12,12,12,12,12,12,12,12,12,12,12,12,12,12,12,12,12,12,12,12,12,12,12,12,12,12,12,12,255,192,0,17,8,0,210,0,150,3,1,34,0,2,17,1,3,17,1,255,196,0,31,0,0,1,5,1,1,1,1,1,1,0,0,0,0,0,0,0,0,1
</code></pre><ul>
<li>google一下，得到信息指向这是UIIMAGE形式的数据。(其实这就是一张jpg图片的原始内容，数字都是10进制的。)</li>
<li><p>为什么不是16进制呢，10进制衬不出气质的呀</p>
</li>
<li><p>大概iphone應用的開發中常用吧，現在呢我就想把它還原成jpeg的圖片。这句自然也错了</p>
</li>
</ul>
<ol>
<li>把字符串split，賦給s2</li>
<li>打印出來<br> for num, _ in enumerate(s2):<pre><code>print &apos;%.2X&apos;%int(_),
if not (num+1)%16:
    print
</code></pre></li>
</ol>
<ul>
<li>正确的解决办法是先读取到完整的数据</li>
<li><p>然后把数字转换成对应的字符，再把字符拼接在一起以jpg为后缀保存文件</p>
</li>
<li><p>更正确的方法是，读取的时候就是图片数据，只要当成图片来显示就正常了。</p>
</li>
</ul>
</div><div class="article-meta"></div><div class="article-comment"><div class="ds-thread" id="ds-thread" data-thread-key="ciwrw13x70006wdddx88oxirq" data-title="碰到IMAGE类型数据后，误以为是UIIAMGE" data-url="http://blog.fudan.pro/2016/12/16/2015-08-03-SthaboutUIIMAGE/" site-name="ueibo"></div><script>var siteName = document.getElementById('ds-thread').getAttribute('site-name');
var duoshuoQuery = {short_name: siteName};
(function() {
  var ds = document.createElement('script');
  ds.type = 'text/javascript';ds.async = true;
  ds.src = (document.location.protocol == 'https:' ? 'https:' : 'http:') + '//static.duoshuo.com/embed.js';
  ds.charset = 'UTF-8';
  (document.getElementsByTagName('head')[0] 
  || document.getElementsByTagName('body')[0]).appendChild(ds);
})();</script></div><ul class="navication"><li class="home"><a href="/"><i class="icon icon-home"></i></a></li><li><a href="/2016/12/16/2015-10-25-DESpython/"><i class="icon icon-arror-left"></i></a></li></ul><div class="page-footer"><div class="top"><ul class="social"><li><a href="http://github.com/BoizZ" title="GitHub" target="_blank"><i class="icon icon-github"></i></a></li><li><a href="http://weibo.com/heqibang" title="Weibo" target="_blank"><i class="icon icon-weibo"></i></a></li><li><a href="http://www.segmentfault.com/u/bon" title="SegmentFault" target="_blank"><i class="icon icon-segmentfault"></i></a></li></ul></div><div class="bottom"><p class="copyright">© 2016 Chen's Blog<br><small>POWER BY <a href="https://hexo.io" target="_blank">HEXO</a></small><small>, THEME BY <a href="https://github.com/BoizZ/hexo-theme-laughing" target="_blank">LAUGHING</a></small></p></div></div></body></html>